| LPCOpen Platform v1.03 LPCOpen Platform for NXP LPC Microcontrollers

- Main Page
- Modules
- Data Structures
- Files
- Related Pages

All Data Structures Files Functions Variables Typedefs Enumerations Enumerator Macros Groups Pages
Data Structures | Macros | Enumerations | Functions
Still Image Class Host Mode Driver
Still Image Class Driver

## Detailed Description

# Module Source Dependencies

The following files must be built with any user project that uses this module:

- LPCUSBlib/Drivers/USB/Class/Host/StillImage.c (Makefile source module name: LPCUSBlib_SRC_USBCLASS)

# Module Description

Host Mode USB Class driver framework interface, for the Still Image USB Class driver.

## Data Structures
struct | USB_ClassInfo_SI_Host_t
| Still Image Class Host Mode Configuration and State Structure. More...

## Macros
#define | SI_ERROR_LOGICAL_CMD_FAILED 0x80

## Enumerations
enum | SI_Host_EnumerationFailure_ErrorCodes_t { SI_ENUMERROR_NoError = 0, SI_ENUMERROR_InvalidConfigDescriptor = 1, SI_ENUMERROR_NoCompatibleInterfaceFound = 2, SI_ENUMERROR_PipeConfigurationFailed = 3 }

## Functions
uint8_t | SI_Host_ConfigurePipes (USB_ClassInfo_SI_Host_t *const SIInterfaceInfo, uint16_t ConfigDescriptorSize, void *ConfigDescriptorData) ATTR_NON_NULL_PTR_ARG(1) ATTR_NON_NULL_PTR_ARG(3)
| Host interface configuration routine, to configure a given Still Image host interface instance using the Configuration Descriptor read from an attached USB device. This function automatically updates the given Still Image Host instance's state values and configures the pipes required to communicate with the interface if it is found within the device. This should be called once after the stack has enumerated the attached device, while the host state machine is in the Addressed state.
uint8_t | SI_Host_OpenSession (USB_ClassInfo_SI_Host_t *const SIInterfaceInfo) ATTR_NON_NULL_PTR_ARG(1)
| Opens a new PIMA session with the attached device. This should be used before any session-orientated PIMA commands are issued to the device. Only one session can be open at the one time.
uint8_t | SI_Host_CloseSession (USB_ClassInfo_SI_Host_t *const SIInterfaceInfo) ATTR_NON_NULL_PTR_ARG(1)
| Closes an already opened PIMA session with the attached device. This should be used after all session-orientated PIMA commands have been issued to the device.
uint8_t | SI_Host_SendBlockHeader (USB_ClassInfo_SI_Host_t *const SIInterfaceInfo, PIMA_Container_t *const PIMAHeader) ATTR_NON_NULL_PTR_ARG(1) ATTR_NON_NULL_PTR_ARG(2)
| Sends a raw PIMA block header to the device, filling out the transaction ID automatically. This can be used to send arbitrary PIMA blocks to the device with or without parameters.
uint8_t | SI_Host_ReceiveBlockHeader (USB_ClassInfo_SI_Host_t *const SIInterfaceInfo, PIMA_Container_t *const PIMAHeader) ATTR_NON_NULL_PTR_ARG(1) ATTR_NON_NULL_PTR_ARG(2)
| Receives a raw PIMA block header from the device. This can be used to receive arbitrary PIMA blocks from the device with or without parameters.
uint8_t | SI_Host_SendCommand (USB_ClassInfo_SI_Host_t *const SIInterfaceInfo, const uint16_t Operation, const uint8_t TotalParams, uint32_t *const Params) ATTR_NON_NULL_PTR_ARG(1)
| Sends a given PIMA command to the attached device, filling out the PIMA command header's Transaction ID automatically.
uint8_t | SI_Host_ReceiveResponse (USB_ClassInfo_SI_Host_t *const SIInterfaceInfo) ATTR_NON_NULL_PTR_ARG(1)
| Receives and checks a response block from the attached Still Image device, once a command has been issued and all data associated with the command has been transferred.
bool | SI_Host_IsEventReceived (USB_ClassInfo_SI_Host_t *const SIInterfaceInfo) ATTR_NON_NULL_PTR_ARG(1)
| Indicates if the device has issued a PIMA event block to the host via the asynchronous events pipe.
uint8_t | SI_Host_ReceiveEventHeader (USB_ClassInfo_SI_Host_t *const SIInterfaceInfo, PIMA_Container_t *const PIMAHeader) ATTR_NON_NULL_PTR_ARG(1) ATTR_NON_NULL_PTR_ARG(2)
| Receives an asynchronous event block from the device via the asynchronous events pipe.
uint8_t | SI_Host_SendData (USB_ClassInfo_SI_Host_t *const SIInterfaceInfo, void *Buffer, const uint16_t Bytes) ATTR_NON_NULL_PTR_ARG(1) ATTR_NON_NULL_PTR_ARG(2)
| Sends arbitrary data to the attached device, for use in the data phase of PIMA commands which require data transfer beyond the regular PIMA command block parameters.
uint8_t | SI_Host_ReadData (USB_ClassInfo_SI_Host_t *const SIInterfaceInfo, void *Buffer, const uint16_t Bytes) ATTR_NON_NULL_PTR_ARG(1) ATTR_NON_NULL_PTR_ARG(2)
| Receives arbitrary data from the attached device, for use in the data phase of PIMA commands which require data transfer beyond the regular PIMA command block parameters.
static void | SI_Host_USBTask (USB_ClassInfo_SI_Host_t *const SIInterfaceInfo) ATTR_NON_NULL_PTR_ARG(1) ATTR_ALWAYS_INLINE
| General management task for a given Still Image host class interface, required for the correct operation of the interface. This should be called frequently in the main program loop, before the master USB management task USB_USBTask().

## Macro Definition Documentation

#define SI_ERROR_LOGICAL_CMD_FAILED 0x80

Error code for some Still Image Host functions, indicating a logical (and not hardware) error.

Definition at line 66 of file StillImageClassHost.h.

## Enumeration Type Documentation

enum SI_Host_EnumerationFailure_ErrorCodes_t

Enum for the possible error codes returned by the SI_Host_ConfigurePipes() function.

Enumerator:

  SI_ENUMERROR_NoError | Configuration Descriptor was processed successfully.
  SI_ENUMERROR_InvalidConfigDescriptor | The device returned an invalid Configuration Descriptor.
  SI_ENUMERROR_NoCompatibleInterfaceFound | A compatible Still Image interface was not found in the device's Configuration Descriptor.
  SI_ENUMERROR_PipeConfigurationFailed | One or more pipes for the specified interface could not be configured correctly.

Definition at line 114 of file StillImageClassHost.h.

## Function Documentation

uint8_t SI_Host_CloseSession | ( | USB_ClassInfo_SI_Host_t *const | SIInterfaceInfo | ) |

Closes an already opened PIMA session with the attached device. This should be used after all session-orientated PIMA commands have been issued to the device.

Precondition
  This function must only be called when the Host state machine is in the HOST_STATE_Configured state or the call will fail.

Parameters

  SIInterfaceInfo | : Pointer to a structure containing a Still Image Class host configuration and state.

Returns
  A value from the Pipe_Stream_RW_ErrorCodes_t enum, or SI_ERROR_LOGICAL_CMD_FAILED if the device returned a logical command failure.

Definition at line 412 of file StillImageClassHost.c.

uint8_t SI_Host_ConfigurePipes | ( | USB_ClassInfo_SI_Host_t *const | SIInterfaceInfo,
|  | uint16_t | ConfigDescriptorSize,
|  | void * | ConfigDescriptorData
| ) |  |

Host interface configuration routine, to configure a given Still Image host interface instance using the Configuration Descriptor read from an attached USB device. This function automatically updates the given Still Image Host instance's state values and configures the pipes required to communicate with the interface if it is found within the device. This should be called once after the stack has enumerated the attached device, while the host state machine is in the Addressed state.

Parameters

  SIInterfaceInfo | : Pointer to a structure containing a Still Image Class host configuration and state.
  ConfigDescriptorSize | : Length of the attached device's Configuration Descriptor.
  ConfigDescriptorData | : Pointer to a buffer containing the attached device's Configuration Descriptor.

Returns
  A value from the SI_Host_EnumerationFailure_ErrorCodes_t enum.

Definition at line 43 of file StillImageClassHost.c.

bool SI_Host_IsEventReceived | ( | USB_ClassInfo_SI_Host_t *const | SIInterfaceInfo | ) |

Indicates if the device has issued a PIMA event block to the host via the asynchronous events pipe.

Precondition
  This function must only be called when the Host state machine is in the HOST_STATE_Configured state or the call will fail.

Parameters

  SIInterfaceInfo | : Pointer to a structure containing a Still Image Class host configuration and state.

Returns
  Boolean `true` if an event is waiting to be read, `false` otherwise.

Definition at line 339 of file StillImageClassHost.c.

uint8_t SI_Host_OpenSession | ( | USB_ClassInfo_SI_Host_t *const | SIInterfaceInfo | ) |

Opens a new PIMA session with the attached device. This should be used before any session-orientated PIMA commands are issued to the device. Only one session can be open at the one time.

Precondition
  This function must only be called when the Host state machine is in the HOST_STATE_Configured state or the call will fail.

Parameters

  SIInterfaceInfo | : Pointer to a structure containing a Still Image Class host configuration and state.

Returns
  A value from the Pipe_Stream_RW_ErrorCodes_t enum, or SI_ERROR_LOGICAL_CMD_FAILED if the device returned a logical command failure.

Definition at line 378 of file StillImageClassHost.c.

uint8_t SI_Host_ReadData | ( | USB_ClassInfo_SI_Host_t *const | SIInterfaceInfo,
|  | void * | Buffer,
|  | const uint16_t | Bytes
| ) |  |

Receives arbitrary data from the attached device, for use in the data phase of PIMA commands which require data transfer beyond the regular PIMA command block parameters.

Precondition
  This function must only be called when the Host state machine is in the HOST_STATE_Configured state or the call will fail.

Parameters

  SIInterfaceInfo | : Pointer to a structure containing a Still Image Class host configuration and state.
  Buffer | : Pointer to a buffer where the received data is to be stored.
  Bytes | : Length in bytes of the data to read.

Returns
  A value from the Pipe_Stream_RW_ErrorCodes_t enum.

Definition at line 319 of file StillImageClassHost.c.

uint8_t SI_Host_ReceiveBlockHeader | ( | USB_ClassInfo_SI_Host_t *const | SIInterfaceInfo,
|  | PIMA_Container_t *const | PIMAHeader
| ) |  |

Receives a raw PIMA block header from the device. This can be used to receive arbitrary PIMA blocks from the device with or without parameters.

Precondition
  This function must only be called when the Host state machine is in the HOST_STATE_Configured state or the call will fail.

Parameters

  SIInterfaceInfo | : Pointer to a structure containing a Still Image Class host configuration and state.
  PIMAHeader | : Pointer to a PIMA container structure where the received block is to be stored.

Returns
  A value from the Pipe_Stream_RW_ErrorCodes_t enum.

Definition at line 232 of file StillImageClassHost.c.

uint8_t SI_Host_ReceiveEventHeader | ( | USB_ClassInfo_SI_Host_t *const | SIInterfaceInfo,
|  | PIMA_Container_t *const | PIMAHeader
| ) |  |

Receives an asynchronous event block from the device via the asynchronous events pipe.

Precondition
  This function must only be called when the Host state machine is in the HOST_STATE_Configured state or the call will fail.

Parameters

  SIInterfaceInfo | : Pointer to a structure containing a Still Image Class host configuration and state.
  PIMAHeader | : Pointer to a PIMA container structure where the event should be stored.

Returns
  A value from the Pipe_Stream_RW_ErrorCodes_t enum, or SI_ERROR_LOGICAL_CMD_FAILED if the device returned a logical command failure.

Definition at line 358 of file StillImageClassHost.c.

uint8_t SI_Host_ReceiveResponse | ( | USB_ClassInfo_SI_Host_t *const | SIInterfaceInfo | ) |

Receives and checks a response block from the attached Still Image device, once a command has been issued and all data associated with the command has been transferred.

Precondition
  This function must only be called when the Host state machine is in the HOST_STATE_Configured state or the call will fail.

Parameters

  SIInterfaceInfo | : Pointer to a structure containing a Still Image Class host configuration and state.

Returns
  A value from the Pipe_Stream_RW_ErrorCodes_t enum, or SI_ERROR_LOGICAL_CMD_FAILED if the device returned a logical command failure.

Definition at line 470 of file StillImageClassHost.c.

uint8_t SI_Host_SendBlockHeader | ( | USB_ClassInfo_SI_Host_t *const | SIInterfaceInfo,
|  | PIMA_Container_t *const | PIMAHeader
| ) |  |

Sends a raw PIMA block header to the device, filling out the transaction ID automatically. This can be used to send arbitrary PIMA blocks to the device with or without parameters.

Precondition
  This function must only be called when the Host state machine is in the HOST_STATE_Configured state or the call will fail.

Parameters

  SIInterfaceInfo | : Pointer to a structure containing a Still Image Class host configuration and state.
  PIMAHeader | : Pointer to a PIMA container structure that is to be sent.

Returns
  A value from the Pipe_Stream_RW_ErrorCodes_t enum.

Definition at line 200 of file StillImageClassHost.c.

uint8_t SI_Host_SendCommand | ( | USB_ClassInfo_SI_Host_t *const | SIInterfaceInfo,
|  | const uint16_t | Operation,
|  | const uint8_t | TotalParams,
|  | uint32_t *const | Params
| ) |  |

Sends a given PIMA command to the attached device, filling out the PIMA command header's Transaction ID automatically.

Precondition
  This function must only be called when the Host state machine is in the HOST_STATE_Configured state or the call will fail.

Parameters

  SIInterfaceInfo | : Pointer to a structure containing a Still Image Class host configuration and state.
  Operation | : PIMA operation code to issue to the device.
  TotalParams | : Total number of 32-bit parameters to send to the device in the issued command block.
  Params | : Pointer to an array of 32-bit values containing the parameters to send in the command block.

Returns
  A value from the Pipe_Stream_RW_ErrorCodes_t enum, or SI_ERROR_LOGICAL_CMD_FAILED if the device returned a logical command failure.

Definition at line 443 of file StillImageClassHost.c.

uint8_t SI_Host_SendData | ( | USB_ClassInfo_SI_Host_t *const | SIInterfaceInfo,
|  | void * | Buffer,
|  | const uint16_t | Bytes
| ) |  |

Sends arbitrary data to the attached device, for use in the data phase of PIMA commands which require data transfer beyond the regular PIMA command block parameters.

Precondition
  This function must only be called when the Host state machine is in the HOST_STATE_Configured state or the call will fail.

Parameters

  SIInterfaceInfo | : Pointer to a structure containing a Still Image Class host configuration and state.
  Buffer | : Pointer to a buffer where the data to send has been stored.
  Bytes | : Length in bytes of the data in the buffer to send to the attached device.

Returns
  A value from the Pipe_Stream_RW_ErrorCodes_t enum.

Definition at line 298 of file StillImageClassHost.c.

static void SI_Host_USBTask | ( | USB_ClassInfo_SI_Host_t *const | SIInterfaceInfo | ) |
| inline static

General management task for a given Still Image host class interface, required for the correct operation of the interface. This should be called frequently in the main program loop, before the master USB management task USB_USBTask().

Parameters

  SIInterfaceInfo | : Pointer to a structure containing a Still Image Class host configuration and state.

Returns
  Nothing

Definition at line 295 of file StillImageClassHost.h.